module Swap
open Heap
open ST

val swap_add_sub : r1:ref int -> r2:ref int -> St unit
      (requires (fun h' -> contains h' r1 /\ contains h' r2 /\ r1<>r2))
      (ensures (fun h' _ h ->
                  let x1 = sel h' r1 in
                  let x2 = sel h' r2 in
                  equal h (upd (upd h' r1 x2) r2 x1)))
let swap_add_sub r1 r2 =
  write r1 (read r1 + read r2);
  write r2 (read r1 - read r2);
  write r1 (read r1 - read r2)

val swap : #a:Type -> r1:ref a -> r2:ref a -> St unit
      (requires (fun h' -> contains h' r1 /\ contains h' r2))
      (ensures (fun h' _ h ->
                  let x1 = sel h' r1 in
                  let x2 = sel h' r2 in
                  equal h (upd (upd h' r1 x2) r2 x1)))
let swap r1 r2 =
  let tmp = read r1 in
  let _ = write r1 (read r2) in
  write r2 tmp
